/*
	echoserver.c - Module file for Echo Server demo using netLib
	v0.3 - 2007.06.26
	Coded by Ian Seyler (iseyler@gmail.com)
	http://bubbai.ath.cx/projects/netlib/
*/


#include "netLib.h"
#include <string.h>

int main()
{
	int tint;
	netSocket *clientsocket;
	netSocket *listensocket;
	netBuffer *tempbuffer;

	printf("Echo Server demo for netLib v0.3\n");

	netInit(); // Start the netLib library

	clientsocket = netInitSocket();
	listensocket = netInitSocket(); // initiate the socket
	tempbuffer = netInitBuffer(1); // create a 1 byte buffer

	netListen(listensocket, 8192); // Set the server to listen on port 8192

	// Main program loop
	for (;;)
	{
		if (netAccept(listensocket, clientsocket) > 0) // a client has connected
		{
			for (;;)
			{
				tint = netRecvBuffer(clientsocket, tempbuffer); // Get a byte from the client
				if (tint > 0)
				{
					printf("\nGot %c", tempbuffer->data[0]); // Print the char we got
					netSendBuffer(clientsocket, tempbuffer); // Send it back to the client
				}
				else if (tint == -1)
				{
					break;
				}
			}
		}
		else
		{
			printf(".");
		}
	}

	netDisconnect(listensocket);

	netStop(); // Stop the netLib library

	printf("\n");
	return 0;
}
